// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit naming;

interface

uses
  name_int,orb_int,orb,types;

type

  {** Implements org.omg.CosNaming.NamingContextOperations }
  TNamingContext = class(TORBObject,IORBObject,INamingContext)
  protected
    procedure bind(name: TName;const obj : IORBObject);
    function resolve(name: TName): IORBObject;
  public
    class function narrow(const obj : IORBObject): INamingContext;
  end;

implementation

uses
  stdstat,static,code_int,req_int;

//*************************************************************************
//  TNamingContext
//*************************************************************************
class function TNamingContext.narrow(const obj : IORBObject): INamingContext;
begin
  result := TNamingContext.Create();
  result.Assign(obj);
end;

procedure TNamingContext.bind(name:TName;const obj : IORBObject);
var
  inp : IStaticAny;
  ob : IStaticAny;
  req : IStaticRequest;
begin
  inp := TStaticAny.Create(stat_seq_NameComponent,@name);
  ob := TStaticAny.Create(stat_Object,@obj);
  req := TStaticRequest.Create(self,'bind');
  req.add_in_arg(inp);
  req.add_in_arg(ob);
  req.Invoke;
  // exception handler not implemented
end;

function TNamingContext.resolve(name: TName): IORBObject;
var
  inp : IStaticAny;
  outp : IStaticAny;
  obj : IORBObject;
  req : IStaticRequest;
begin
  inp := TStaticAny.Create(stat_seq_NameComponent,@name);
  outp := TStaticAny.Create(stat_Object,@obj);
  req := TStaticRequest.Create(self,'resolve');
  req.set_result(outp);
  req.add_in_arg(inp);
  req.Invoke;
  result := obj;
end;

end.
