// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit env_int;

interface

uses
  except_int,code_int,classes,types;

type

  IContext = interface
  ['{61252F70-4D23-11d4-9D27-204C4F4F5020}']
    function context_name(): PChar;
    function parent(): IContext;
    procedure encode(const enc: IEncoder; const ctxlist: IInterfaceList);
    function decode(const dec: IDecoder): Boolean;
  end;


  TNamedValue = record
    name : Identifier;
    argument : IAny;
    len : long;
    flags : _ulong;
  end;

  NVList = array of TNamedValue;

  {**  Helper for NVList }
  INVList = interface
  ['{61252F72-4D23-11d4-9D27-204C4F4F5020}']
    function add(flags: _ulong): TNamedValue;
    function add_item(name: Identifier;flags: _ulong): TNamedValue;
    function add_value(name: Identifier; any: IAny; flags: _ulong): TNamedValue;
    function count: integer;
    procedure delete(index: integer);
    function item(index: integer): TNamedValue;
    function copy(const src: INVList;flags: _ulong): Boolean;
  end;

  IStaticAnyList = interface(IInterfaceList)
  ['{61252F73-4D23-11d4-9D27-204C4F4F5020}']
    function _Get(Index: Integer): IStaticAny;
    procedure _Put(Index: Integer; Item: IStaticAny);
    property Items[Index: Integer]: IStaticAny read _Get write _Put; default;
  end;

  IEnvironment = interface
  ['{61252F75-4D23-11d4-9D27-204C4F4F5020}']
    function get_exception(): IORBException;
    procedure set_exception(const ex: IORBException);
    function principal(): IPrincipal;
    procedure clear();
  end;

implementation

end.
